#!/usr/bin/env python
# -*- coding: utf-8 -*-

# This is sample "one-to-one proxy", supporting multiple clients
# (Developed testing the client part of network.py)

from blamlib import network
import time, sys

class Proxy_Server( network.TCP_Server ):
    tunnels = [] # The clients
    remote_host = unicode()
    remote_port = int()
    
    def __init__( self, host, port, remote_host, remote_port ):
        network.TCP_Server.__init__( self, host, port )
        self.remote_host = remote_host
        self.remote_port = remote_port
    
    def on_connect( self, client ):
        self.tunnels.append( Proxy_Tunnel( self.remote_host,
                                           self.remote_port,
                                           client ) )
    
    def on_disconnect( self, client ):
        affected_tunnel = filter(
            lambda tunnel: tunnel.client_sock == client,
            self.tunnels )
       
        affected_tunnel[0].close()

        # remove the closed tunnel
        self.tunnels = filter( lambda tunnel: tunnel.client_sock != client,
                               self.tunnels )

        print "Lost a tunnel"
        
    def poll( self ):
        network.TCP_Server.poll( self )
        map( lambda tunnel: tunnel.poll(), self.tunnels )

    def handle( self, client, data ):
        print "client> '%s'" % data.strip()
        
        affected_tunnel = filter(
            lambda tunnel: tunnel.client_sock == client,
            self.tunnels )

        map( lambda tunnel: tunnel.write( data ),
             affected_tunnel )

# Client test (connect to a perm session)
class Proxy_Tunnel( network.TCP_Client ):
    client_sock = None

    def __init__( self, host, port, client_sock ):
        network.TCP_Client.__init__( self, host, port )
        self.client_sock = client_sock
    
    def on_connect( self ):
        print u"Tunnel established to %s:%d" %( self.host, self.port )

    def on_disconnect( self ):
        print u"Tunnel to %s:%d collapsed" %( self.host, self.port )
        self.client_sock.close()

    def handle( self, data ):
        print "server> '%s'" % data.strip()
        self.client_sock.write( data )

if __name__ == '__main__':
    print "tcp-snoper (a simple one-one proxy (supporting multiple clients)"

    if len( sys.argv ) != 4:
        print "Usage: tcp-snoper.py listen-port host port"
        sys.exit( 1 )
        
    proxy = Proxy_Server( "", int( sys.argv[1] ), sys.argv[2],
                          int( sys.argv[3] ) )

    while proxy.net_sock: # will become None if closed
        proxy.poll()
        time.sleep( 0.001 )
