#!/usr/bin/env python
# -*- coding: utf-8 -*-

import time
from blamlib import network

class Teg_Bot( network.TCP_Client ):
    """A simple hack just, for fun, testing what it takes to
    write a simple bot"""

    observer = True
    bot = True # Auth as a bot (FIXME)
    authed = False
    nick = str()
    my_id = int()
    client_version = "TEG-logger(Teg_Bot) version 0.0.0"
    
    def __init__( self, host, port, nick="kurt", observer=True, bot=True ):
        self.observer = observer
        self.bot = bot
        self.nick = nick
        network.Network_TCP_Client.__init__( self, host, port )
    
    def on_connect( self ):
        # init auth
        self.write( "protocol_version=6,0\n" )
        self.write( "server_version\n" )

    def handle( self, data ):

        if not self.authed:
            if data.startswith( "protocol_version" ):
                data = data.split('\n')
                print "SP: %s" % data[0]
                print "SV: %s" % data[1]
                self.write( "client_version=%s\n" % self.client_version )
                self.write( "player_id=%s,0,1\n" % self.nick )

            elif data.startswith( "player_id" ):
                self.my_id = int( data.split(',')[1] )
                print "PID: %d" % self.my_id
                self.authed = True

        else:
            if data.startswith( "msg=" ):
                nick, sender_id, text = data[4:].split(',')
                self.on_msg( nick, int( sender_id ), text[1:-2] )

    def on_msg( self, nick, sender_id,  text ):
        """get message from nick with the message text"""
        print "<%s> %s" %( nick, text )

        if sender_id != self.my_id and nick != self.nick:
            self.send_msg( "TYST!!!" )
        
    def send_msg( self, text ):
        """send message text"""
        self.write( 'msg="%s"\n' % text )



print "python client for teg"

tb = Teg_Bot( "localhost", 2000 )

while tb.connected:
    tb.poll()
    time.sleep( 0.01 )
    
